<script setup>
import { ref } from 'vue';
import { Inertia } from '@inertiajs/inertia';
import { useForm } from '@inertiajs/inertia-vue3';
import JetButton from '@/Jetstream/Button.vue';
import JetFormSection from '@/Jetstream/FormSection.vue';
import JetInput from '@/Jetstream/Input.vue';
import JetTextarea from '@/Jetstream/Textarea.vue';
import JetInputError from '@/Jetstream/InputError.vue';
import JetLabel from '@/Jetstream/Label.vue';
import JetActionMessage from '@/Jetstream/ActionMessage.vue';
import JetSecondaryButton from '@/Jetstream/SecondaryButton.vue';
import JetSelect from '@/Jetstream/Select.vue';
import vSelect from 'vue-select'
import 'vue-select/dist/vue-select.css';
const props = defineProps({
    companyProfile: Object,
});

const form = useForm({
    _method: 'PUT',
    name: props.companyProfile.name,
    description: props.companyProfile.description,
    address: props.companyProfile.address,
    website_url: props.companyProfile.website_url,
    photo: null,
    job_area_id:props.companyProfile.job_area_id,
});

const photoPreview = ref(null);
const photoInput = ref(null);

const updateProfileInformation = () => {
    if (photoInput.value) {
        form.photo = photoInput.value.files[0];
    }

    form.post(route('company-profile-information.update'), {
        errorBag: 'updateProfileInformation',
        preserveScroll: true,
        onSuccess: () => clearPhotoFileInput(),
    });
};

const selectNewPhoto = () => {
    photoInput.value.click();
};

const updatePhotoPreview = () => {
    const photo = photoInput.value.files[0];

    if (! photo) return;

    const reader = new FileReader();

    reader.onload = (e) => {
        photoPreview.value = e.target.result;
    };

    reader.readAsDataURL(photo);
};

const deletePhoto = () => {
    Inertia.delete(route('current-user-company-photo.destroy'), {
        preserveScroll: true,
        onSuccess: () => {
            photoPreview.value = null;
            clearPhotoFileInput();
        },
    });
};

const clearPhotoFileInput = () => {
    if (photoInput.value?.value) {
        photoInput.value.value = null;
    }
};
</script>

<template>
    <JetFormSection @submitted="updateProfileInformation">
        <template #title>
            Company Profile Information
        </template>

        <template #description>
            Update your account's company profile information.
        </template>

        <template #form>
            <!-- Profile Photo -->
            <div v-if="$page.props.jetstream.managesProfilePhotos" class="col-span-6 sm:col-span-4">
                <!-- Profile Photo File Input -->
                <input
                    ref="photoInput"
                    type="file"
                    class="hidden"
                    @change="updatePhotoPreview"
                >

                <JetLabel for="photo" value="Photo" />

                <!-- Current Profile Photo -->
                <div v-show="! photoPreview" class="mt-2">
                    <img :src="companyProfile.profile_photo_url" :alt="companyProfile.name" class="rounded-full h-20 w-20 object-cover">
                </div>

                <!-- New Profile Photo Preview -->
                <div v-show="photoPreview" class="mt-2">
                    <span
                        class="block rounded-full w-20 h-20 bg-cover bg-no-repeat bg-center"
                        :style="'background-image: url(\'' + photoPreview + '\');'"
                    />
                </div>

                <JetSecondaryButton class="mt-2 mr-2" type="button" @click.prevent="selectNewPhoto">
                    Select A New Photo
                </JetSecondaryButton>

                <JetSecondaryButton
                    v-if="companyProfile.profile_photo_path"
                    type="button"
                    class="mt-2"
                    @click.prevent="deletePhoto"
                >
                    Remove Photo
                </JetSecondaryButton>

                <JetInputError :message="form.errors.photo" class="mt-2" />
            </div>

            <!-- Name -->
            <div class="col-span-6 sm:col-span-4">
                <JetLabel for="name" value="Name" />
                <JetInput
                    id="name"
                    v-model="form.name"
                    type="text"
                    class="mt-1 block w-full"
                    autocomplete="name"
                />
                <JetInputError :message="form.errors.name" class="mt-2" />
            </div>

            <div class="col-span-6 sm:col-span-4">
                <JetLabel for="website_url" value="Website URL" />
                <JetInput
                        id="website_url"
                        v-model="form.website_url"
                        type="text"
                        class="mt-1 block w-full"
                        autocomplete="website_url"
                />
                <JetInputError :message="form.errors.website_url" class="mt-2" />
            </div>

            <div class="col-span-6 sm:col-span-4">
                <JetLabel for="job_area_id" value="Job Area" />

                <vSelect
                        id="job_area_id"
                        v-model="form.job_area_id"
                        :value="form.job_area_id"
                        class="mt-1 block w-full"
                        autocomplete="job_area_id"
                        placeholder="Select Job Area"
                        :options="options"
                        :reduce="(option) => option.id"
                        label="name"
                />
                <JetInputError :message="form.errors.job_area_id" class="mt-2" />
            </div>

            <div class="col-span-6 sm:col-span-4">
                <JetLabel for="description" value="Description" />
                <JetTextarea
                        id="description"
                        v-model="form.description"
                        type="text"
                        class="mt-1 block w-full"
                />
                <JetInputError :message="form.errors.description" class="mt-2" />
            </div>

            <div class="col-span-6 sm:col-span-4">
                <JetLabel for="address" value="Address" />
                <JetTextarea
                        id="address"
                        v-model="form.address"
                        type="text"
                        class="mt-1 block w-full"
                />
                <JetInputError :message="form.errors.address" class="mt-2" />
            </div>

        </template>

        <template #actions>
            <JetActionMessage :on="form.recentlySuccessful" class="mr-3">
                Saved.
            </JetActionMessage>

            <JetButton :class="{ 'opacity-25': form.processing }" :disabled="form.processing">
                Save
            </JetButton>
        </template>
    </JetFormSection>
</template>

<script>
    export default {
        data() {
            return {
                options: [],
            };
        },
        methods:{
            fetchAreas()
            {

                let here = this;
                axios.get(route('job.areas.index')).then(response => {
                    console.log('response',response);
                    here.options = response.data;
                });


            }
        },
        mounted(){
            this.fetchAreas();
        }
    }
</script>